package jbpmExplained;

import org.drools.event.process.ProcessCompletedEvent;
import org.drools.event.process.ProcessEventListener;
import org.drools.event.process.ProcessNodeLeftEvent;
import org.drools.event.process.ProcessNodeTriggeredEvent;
import org.drools.event.process.ProcessStartedEvent;
import org.drools.event.process.ProcessVariableChangedEvent;

public class MyProcessEventListener implements ProcessEventListener {

	public void beforeProcessStarted(ProcessStartedEvent event) {
		System.out.println("Starting process");
	}

	public void afterProcessStarted(ProcessStartedEvent event) {
		System.out.println("Process started");
	}

	public void beforeProcessCompleted(ProcessCompletedEvent event) {
		System.out.println("Process " + event.getProcessInstance().getProcessId() + " going to be completed");
	}

	public void afterProcessCompleted(ProcessCompletedEvent event) {
		System.out.println("Process " + event.getProcessInstance().getProcessId() + " completed");
	}

	public void beforeNodeTriggered(ProcessNodeTriggeredEvent event) {
		System.out.println("Tirggereing node: " + event.getNodeInstance().getNodeName());
	}

	public void afterNodeTriggered(ProcessNodeTriggeredEvent event) {
		System.out.println("Triggered node: " + event.getNodeInstance().getNodeName());
	}

	public void beforeNodeLeft(ProcessNodeLeftEvent event) {
		System.out.println("Leaving node: " + event.getNodeInstance().getNodeName());
	}

	public void afterNodeLeft(ProcessNodeLeftEvent event) {
		System.out.println("Left node: " + event.getNodeInstance().getNodeName());
	}

	public void beforeVariableChanged(ProcessVariableChangedEvent event) {
		System.out.println("changing Process Variable from: " + event.getOldValue());
	}

	public void afterVariableChanged(ProcessVariableChangedEvent event) {
		System.out.println("changed process variable to: " + event.getNewValue());
	}

}
